<?php
/**
 * @author Michael Wandel, THAVIS GmbH & Co. KG
 * @author <a href="http://www.thavis.com">www.thavis.com</a>
 * @package redaxo4 
 * @version $Id: urlRewrite.inc.php 357 2013-11-12 17:04:35Z mwandel $
 */
 
 
	if (OOAddon :: isAvailable('rexseo')) {
		require_once dirname(__FILE__) ."/../../rexseo/classes/class.rexseo_rewrite.inc.php";
	}
	
	if (OOAddon :: isAvailable('seo42')) {
		require_once dirname(__FILE__) ."/../../seo42/classes/class.rexseo_rewrite.inc.php";
	}

/*
 * Gibt die URL des Artikels zurueck.
 * @param int $cat_id ID der Kategorie
 * @param int $clang Redaxo SprachID
 * @return String URL des Artikels
 */
function getTvsShopUrl($m_art_id = '', $clang = 0) {
  
	global $REX;

	$mytvsshopIniFile	= $REX['INCLUDE_PATH'] . "/addons/tvsshop/tvsshop.ini";
	$tvsshopsettings	= parse_ini_file($mytvsshopIniFile );
	$shopArticle_id		= $tvsshopsettings['shopArticle_id'];

	$url = $REX['SERVER'];

	if ($shopArticle_id != "") {
		$table_pre			= $REX['TABLE_PREFIX'].$REX['ADDON']['rxid']['tvsshop'];
		$tvsshop_art_table	= $table_pre . "_articles";
		$tvsshop_cat_table	= $table_pre . "_categories";
		$pathname			= '';

		$query_art = "SELECT  a.title as art_title, a.id as art_id 
					  FROM " . $tvsshop_art_table . " as a
					  WHERE a.status = 1 
					  AND a.id = ". $m_art_id;
					  
		$sql_art = new rex_sql();
		$sql_art -> setQuery($query_art);
		$rows_art = $sql_art -> getRows();

		for($j = 0; $j < $rows_art; $j++) {

			$art_id		= $sql_art->getValue("art_id");
			$art_title	= $sql_art->getValue("art_title");

			$pathname = '';

			// Option fuer Mehrsprachigkeit
			if (OOAddon :: isAvailable('rexseo'))
				if (count($REX['CLANG']) > 1 && $clang != $REX['ADDON']['rexseo']['settings']['hide_langslug'])
					$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$clang], $REX['START_ARTICLE_ID'], $clang);

			if (OOAddon :: isAvailable('seo42'))
				if (count($REX['CLANG']) > 1 && $clang != $REX['ADDON']['seo42']['settings']['hide_langslug'])
					$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$clang], $REX['START_ARTICLE_ID'], $clang);
		   
			// Erzeugung Artikelname
			$shop_article = OOArticle::getArticleByID($shopArticle_id);
			$shop_article_name = iconv("UTF-8", "ASCII//TRANSLIT", $shop_article->getName());
			$pathname = rexseo_appendToPath($pathname, $shop_article_name, $shopArticle_id, $clang);

			// Erzeugung Artikelname
			$pathname = rexseo_appendToPath($pathname, $art_title, $art_id, $clang);
									
				// ALLGEMEINE URL ENDUNG
			if (OOAddon :: isAvailable('rexseo'))
				$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['rexseo']['settings']['url_ending'];

			if (OOAddon :: isAvailable('seo42'))
				$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['seo42']['settings']['url_ending'];
			
			$sql_art -> next();
		}

		$url .= $pathname;
	}

	return $url;
}

/*
 * Aendert die RexSEO Pfadliste und fuegt die Kategorien/Posttitle des Addons hinzu.
 */
function tvsshop_extended_urls($_params) {
   
	global $REX;

	$mytvsshopIniFile	= $REX['INCLUDE_PATH'] . "/addons/tvsshop/tvsshop.ini";
	$tvsshopsettings	= parse_ini_file($mytvsshopIniFile );
	$shopArticle_id		= $tvsshopsettings['shopArticle_id'];

	if ($shopArticle_id != "") {
		$table_pre			= $REX['TABLE_PREFIX'].$REX['ADDON']['rxid']['tvsshop'];
		$tvsshop_art_table	= $table_pre . "_articles";
		$tvsshop_cat_table	= $table_pre . "_categories";
		$tvsshop_category	= rex_get('tvsshop_category', 'int', -1);


		$query_art = "SELECT * FROM " . $tvsshop_art_table . " WHERE status = 1 ORDER BY title";
				  
		$sql_art = new rex_sql();
		$sql_art -> setQuery($query_art);
		$rows_art = $sql_art -> getRows();
		
		for($j = 0; $j < $rows_art; $j++) {
		  
			$art_id		= $sql_art->getValue("id");       
			$art_title	= $sql_art->getValue("title");   
		  
			$lang_id = 0;
			$pathname = '';
			// Option fuer Mehrsprachigkeit
			if (OOAddon :: isAvailable('rexseo'))
				if (count($REX['CLANG']) > 1 && $lang_id != $REX['ADDON']['rexseo']['settings']['hide_langslug'])
					$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$lang_id], $REX['START_ARTICLE_ID'], $lang_id);

			if (OOAddon :: isAvailable('seo42'))
				if (count($REX['CLANG']) > 1 && $lang_id != $REX['ADDON']['seo42']['settings']['hide_langslug'])
					$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$lang_id], $REX['START_ARTICLE_ID'], $lang_id);

			// Erzeugung Artikelname
			$shop_article = OOArticle::getArticleByID($shopArticle_id, $lang_id);
			$shop_article_name = iconv("UTF-8", "ASCII//TRANSLIT", $shop_article->getName());
			$pathname = rexseo_appendToPath($pathname, $shop_article_name, $shopArticle_id, $lang_id);

			// Erzeugung Artikelname
			$pathname = rexseo_appendToPath($pathname, $art_title, $art_id, $lang_id);
				
			// ALLGEMEINE URL ENDUNG
			if (OOAddon :: isAvailable('rexseo'))
				$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['rexseo']['settings']['url_ending'];

			if (OOAddon :: isAvailable('seo42'))
				$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['seo42']['settings']['url_ending'];

			$_params['subject']['REXSEO_URLS'][$pathname] = array (
				'id'     => $shopArticle_id, 
				'clang'  => $lang_id,
				'params' => array('art_id', $art_id)
			);

			$sql_art -> next();
		}
	}

	return $_params['subject'];

    /*
    Allgemeiner Hinweis:
    1. In der config.inc.php muessen folgende Zeilen hinzugefuegt werden:
    -----%<-----
    require_once dirname(__FILE__) ."/classes/urlRewrite.inc.php";
    rex_register_extension('REXSEO_PATHLIST_CREATED', 'tvsshop_extended_urls');
    -----%<-----

    2. An der Stelle, an der der Post geaendert werden kann muss nach der Aenderung noch folgender Befehl ausgefuehrt werden:
    -----%<-----
    // Pathliste neu generieren
    rexseo_generate_pathlist(array());
    -----%<-----
    */
}

/*
 * Aendert die RexSEO Sitemap und fuegt die URLs des Addons hinzu.
*/
function tvsshop_extended_sitemap($_params) {
  
	global $REX;
    
	$mytvsshopIniFile	= $REX['INCLUDE_PATH'] . "/addons/tvsshop/tvsshop.ini";
	$tvsshopsettings	= parse_ini_file($mytvsshopIniFile );
	$shopArticle_id		= $tvsshopsettings['shopArticle_id'];

	if ($shopArticle_id != "") {
		$table_pre			= $REX['TABLE_PREFIX'].$REX['ADDON']['rxid']['tvsshop'];
		$tvsshop_art_table	= $table_pre . "_articles";
			 
		$query_art	= "SELECT * FROM " . $tvsshop_art_table . " WHERE status = 1 ORDER BY title";

		$sql_art = new rex_sql();
		$sql_art -> setQuery($query_art);
		$rows_art = $sql_art -> getRows();
			
		for($j = 0; $j < $rows_art; $j++) {
			  
			$art_id		= $sql_art->getValue("id");       
			$art_title	= $sql_art->getValue("title"); 
			$art_date	= $sql_art->getValue("create_date"); 

				$lang_id = 0;

				// Option fuer Mehrsprachigkeit
				if (OOAddon :: isAvailable('rexseo')) {
					$pathname = "/";
					if (count($REX['CLANG']) > 1 && $lang_id != $REX['ADDON']['rexseo']['settings']['hide_langslug'])
						$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$lang_id], $REX['START_ARTICLE_ID'], $lang_id);
				}

				if (OOAddon :: isAvailable('seo42')) {
					$pathname = "/";
					if (count($REX['CLANG']) > 1 && $lang_id != $REX['ADDON']['seo42']['settings']['hide_langslug'])
						$pathname = rexseo_appendToPath($pathname, $REX['CLANG'][$lang_id], $REX['START_ARTICLE_ID'], $lang_id);
				}

				// Erzeugung Artikelname
				$shop_article = OOArticle::getArticleByID($shopArticle_id);
				$shop_article_name = iconv("UTF-8", "ASCII//TRANSLIT", $shop_article->getName());
				$pathname = rexseo_appendToPath($pathname, $shop_article_name, $shopArticle_id, $lang_id);

				// Erzeugung Artikelname
				$pathname = rexseo_appendToPath($pathname, $art_title, $art_id, $lang_id);
								
				// ALLGEMEINE URL ENDUNG
				if (OOAddon :: isAvailable('rexseo'))
					$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['rexseo']['settings']['url_ending'];

				if (OOAddon :: isAvailable('seo42'))
					$pathname = substr($pathname,0,strlen($pathname)-1).$REX['ADDON']['seo42']['settings']['url_ending'];

				$add_array[$lang_id] = array(
						'loc' => $pathname,
						'lastmod' => date('c', $art_date),
						'changefreq' => 'daily',
						'priority'   => 0.5
					);
			$_params['subject'][] = $add_array;

			$sql_art -> next();
		}
	}
	return $_params['subject'];
}

?>